#!/usr/bin/env python
# coding: utf-8

#import library
from Bio import SeqIO
from Bio.SeqFeature import SeqFeature, FeatureLocation
from Bio.Graphics import GenomeDiagram
from reportlab.lib.units import cm
from reportlab.lib import colors
import pandas as pd

#Creating Fig5b.
#Prepareing canvas for creating figure for each IS.
#ISLa1
gdd_ISLa1 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa1 = gdd_ISLa1.new_track(1, greytrack=False)
gds_features_ISLa1 = gdt_features_ISLa1.new_set()
#ISLa2
gdd_ISLa2 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa2 = gdd_ISLa2.new_track(1, greytrack=False)
gds_features_ISLa2 = gdt_features_ISLa2.new_set()
#ISLa3
gdd_ISLa3 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa3 = gdd_ISLa3.new_track(1, greytrack=False)
gds_features_ISLa3 = gdt_features_ISLa3.new_set()
#ISLa4
gdd_ISLa4 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa4 = gdd_ISLa4.new_track(1, greytrack=False)
gds_features_ISLa4 = gdt_features_ISLa4.new_set()
#ISLa5
gdd_ISLa5 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa5 = gdd_ISLa5.new_track(1, greytrack=False)
gds_features_ISLa5 = gdt_features_ISLa5.new_set()
#ISLa6
gdd_ISLa6 = GenomeDiagram.Diagram('Test Diagram')
gdt_features_ISLa6 = gdd_ISLa6.new_track(1, greytrack=False)
gds_features_ISLa6 = gdt_features_ISLa6.new_set()

#Creating and Exporting the structure of ISs
#ISLa1
start = [78, 352]
end = [362, 1197]
name = ['Cluster 4(COG2963)', 'Cluster 1(COG2801)']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa1.add_feature(feature, color = 'chartreuse',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 10, label_angle = 10)
    
gdd_ISLa1.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=1463)
gdd_ISLa1.write("Fig5b_ISLa1.pdf", "pdf")

#ISLa2
start = [65, 370, 1206]
end = [349, 1206, 1463]
name = ['Cluster 5(COG2963)', 'Cluster 2(COG2801)', 'Not annotated']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa2.add_feature(feature, color = 'cyan',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 10, label_angle = 10)

gdd_ISLa2.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=1480)
gdd_ISLa2.write("Fig5b_ISLa2.pdf", "pdf")

#ISLa3
start = [66, 353]
end = [356, 1228]
name = ['Cluster 6(COG2963)', 'Cluster 3(COG2801)']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa3.add_feature(feature, color = 'cornflowerblue',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 10, label_angle = 10)

gdd_ISLa3.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=1270)
gdd_ISLa3.write("Fib5b_ISLa3.pdf", "pdf")

#ISLa4
start = [118, 1616]
end = [1629, 2344]
name = ['Cluster 7(COG1484)', 'Cluster 10(COG4584)']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa4.add_feature(feature, color = 'violet',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 10, label_angle = 10)
    
gdd_ISLa4.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=2431)
gdd_ISLa4.write("Fib5b_ISLa4.pdf", "pdf")

#ISLa5
start = [164, 1689]
end = [1696, 2444]
name = ['Cluster 8(COG1484)', 'Cluster 11(COG4584)']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa5.add_feature(feature, color = 'hotpink',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 10, label_angle = 10)

gdd_ISLa5.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=2516)
gdd_ISLa5.write("Fib5b_ISLa5.pdf", "pdf")

#ISLa6
start = [209, 1800]
end = [1759, 2537]
name = ['Cluster 9(COG1484)', 'Cluster 12(COG4584)']
for starts, ends, names in zip(start, end, name):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=None)
    gds_features_ISLa6.add_feature(feature, color = 'orange',  name=names , label=True, sigil = "ARROW", arrowshaft_height=1.0, label_size = 12, label_angle = 10)

gdd_ISLa6.draw(format="linear", orientation="landscape", pagesize=(15*cm,5*cm), fragments=1, start=0, end=2631)
gdd_ISLa6.write("Fib5b_ISLa6.pdf", "pdf")

#Create a canvas for Fig5c.
gdd = GenomeDiagram.Diagram('Test Diagram')
gdt_features = gdd.new_track(1, greytrack=False)
gds_features = gdt_features.new_set()

#Import a table as dataframe that shows the names of the insertion sequences, the genes that each insertion sequence contains, and their locations in the chromosome.
IS_position_table = pd.read_excel('Genome_position_of_sequential_genes.xlsx', sheet_name = 'IS_distribution')
IS_position_table

#Add a column that shows forward strand as +1, reverse strand as -1.
strands = []
for i in IS_position_table['reverse_compliment']:
    if i == 'forseq':
        strands.append(+1)
    else:
        strands.append(-1)   
IS_position_table['strands'] = strands

#Determine the color corresponding to each insert sequence and add it to the table.
IS = ['ISLa1', 'ISLa2', 'ISLa3', 'ISLa4', 'ISLa5','ISLa6', 'Other' ]
colors = ['chartreuse', 'cyan', 'cornflowerblue', 'violet', 'hotpink', 'orange', 'grey']
IS_position_table['colors'] = IS_position_table['IS']
rename = dict(zip(IS, colors))
IS_position_table['colors'] = IS_position_table['colors'].map(rename)
IS_position_table

#Visualizing Fig5c
start = IS_position_table['start_position_of_genes_in_IS']
end = IS_position_table['end_position_of_genes_in_IS']
strand = IS_position_table['strands']
name = IS_position_table['IS']
color = IS_position_table['colors']
for starts, ends, strands, names, colors in zip(start, end, strand, name, color):
    feature = SeqFeature(FeatureLocation(starts, ends), strand=strands)
    gds_features.add_feature(feature, color = colors,  name= names, label=False)

gdd.draw(format='circular', pagesize=(15*cm,15*cm), fragments=1, start=0, end=3750805, circle_core = 0.7)
gdd.write("Fig5c_distribution_of_IS.pdf", "pdf")
