#Installation
	#For instructions on how to download HGTector2, please refer to the following URL, https://github.com/qiyunlab/HGTector.
 	#In addition, you will need to construct local RefSeq database to run this script. 

#Activate hgtector
source activate hgtector

#Input file
	#We used protein fasta file of 17 species as input files which is also stored in folder "0_Genetic_information" 
ls *.fasta | perl -pe 's/.fasta//g' > sequence_list.txt


#Search
	#Batch homology search on input protein sequences against a refseq database were performed by search command.
for sequence_name in `cat sequence_list.txt`
do
hgtector search -i $sequence_name.fasta -o search_$sequence_name -m diamond -p 4 -d diamond -t taxdump
done 

#Analyze
	#HGT-derived genes were predicted based on the distribution of the patterns of sequence homology search results 
	#Legionella (TaxID: 445) was set as the self group, and Legionellales (TaxID: 118969) was set as the close group
	#Quality cutoffs for valid hits were an E value ≤ 1e˗10, percentage identity ≥ 30%, and query coverage ≥ 70%. For each protein coding gene, the top 100 highest-scoring hits from different species were retained.

for sequence_name in `cat sequence_list.txt`
do
hgtector analyze -i search_$sequence_name/*.tsv -o analyze2_$sequence_name -t taxdump --self-tax 445 --close-tax 118969 --evalue 1e-10 --identity 30 --coverage 70 --maxhits 100
done











